package it.pmsc.myapplication;

import android.text.Html;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONObject;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import it.pmsc.myapplication.csr.Progetto;
import it.pmsc.myapplication.mappe.Luogo;
import it.pmsc.myapplication.menu.Piatto;
import it.pmsc.myapplication.servizioclienti.Faq;
import it.pmsc.myapplication.shop.Prodotto;

public class DBAccess {
    List<Luogo> locali;
    boolean errore;

    List<Faq> faqs;
    boolean erroreFaq;

    List<String> regioni;
    boolean erroreRegioni;

    List<String> categorie;
    boolean erroreCategorie;

    List<Prodotto> prodotti;
    boolean erroreProdotti;

    List<Piatto> piatti;
    boolean errorePiatti;

    boolean nuoviPiatti;
    boolean erroreNuoviPiatti;

    List<Progetto>listaProgetti;
    boolean erroreProgetti;

    //richiesta al database di tutte le mense per popolare lo spinner
    public List<Luogo> leggiLocali(final String regione) {
        locali=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/locali.php?regione="+regione);
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("GET");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        Luogo locale = new Luogo(json_data.getString("nome"), json_data.getString("indirizzo"));
                        Log.i("LUOGHI",locale.getIndirizzo());
                        locali.add(locale);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    errore=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(errore==true){
                return null;
            }
            return locali;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<String> leggiRegioni() {
        regioni=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/regioni.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        String regione = json_data.getString("regione");
                        Log.i("LUOGHI",regione);
                        regioni.add(regione);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreRegioni=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreRegioni==true){
                return null;
            }
            return regioni;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<Faq> leggiFAQ() {
        faqs=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/faq.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    Log.i("RESULT",result);
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        Faq faq = new Faq(Html.fromHtml(json_data.getString("domanda")), Html.fromHtml(json_data.getString("risposta")));


                       // Log.i("DOMANDA", faq.getDomanda());
                        faqs.add(faq);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreFaq=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreFaq==true){
                return null;
            }
            return faqs;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<String> leggiCategorieFromTipo(final String tipo) {
        categorie=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/categorie.php?tipo="+tipo);
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("GET");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        String categoria = json_data.getString("categoria");
                        //Log.i("CATEGORIE",categoria);
                        categorie.add(categoria);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreCategorie=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreCategorie==true){
                return null;
            }
            return categorie;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<Prodotto> leggiProdottiFromCategoria(final String categoria) {
        prodotti=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/prodotti.php?categoria="+categoria);
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("GET");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        SimpleDateFormat dataS= new SimpleDateFormat("yyyy-MM-dd");
                        Date dataScadenza=dataS.parse(json_data.getString("data_scadenza"));
                        //Log.i("DATA SCADENZA",dataScadenza.toString());

                        Prodotto prodotto= new Prodotto(json_data.getString("nome_prodotto"),
                                json_data.getDouble("prezzo"),
                                dataScadenza,
                                json_data.getString("categoria"),
                                json_data.getString("tipo"));
                        //Log.i("PRODOTTO",prodotto.getNome());
                        prodotti.add(prodotto);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreProdotti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreProdotti==true){
                return null;
            }
            return prodotti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<Prodotto> leggiTuttiProdotti() {
        prodotti=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/tuttiProdotti.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        SimpleDateFormat dataS= new SimpleDateFormat("yyyy-MM-dd");
                        Date dataScadenza=dataS.parse(json_data.getString("data_scadenza"));
                        //Log.i("DATA SCADENZA",dataScadenza.toString());

                        Prodotto prodotto= new Prodotto(json_data.getString("nome_prodotto"),
                                json_data.getDouble("prezzo"),
                                dataScadenza,
                                json_data.getString("categoria"),
                                json_data.getString("tipo"));
                        //Log.i("PRODOTTO",prodotto.getNome());
                        prodotti.add(prodotto);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreProdotti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreProdotti==true){
                return null;
            }
            return prodotti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<Prodotto> leggiTuttiPiattiPronti() {
        prodotti=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/tuttiPiattiPronti.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        SimpleDateFormat dataS= new SimpleDateFormat("yyyy-MM-dd");
                        Date dataScadenza=dataS.parse(json_data.getString("data_scadenza"));
                        //Log.i("DATA SCADENZA",dataScadenza.toString());

                        Prodotto prodotto= new Prodotto(json_data.getString("nome_prodotto"),
                                json_data.getDouble("prezzo"),
                                dataScadenza,
                                json_data.getString("categoria"),
                                json_data.getString("tipo"));
                        //Log.i("PRODOTTO",prodotto.getNome());
                        prodotti.add(prodotto);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreProdotti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreProdotti==true){
                return null;
            }
            return prodotti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public List<Piatto> leggiPiattiFromTipo(final String tipo) {
        piatti=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/leggiMenu.php?tipo="+tipo);
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("GET");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        SimpleDateFormat data= new SimpleDateFormat("yyyy-MM-dd");
                        Date dataIntroduzione=data.parse(json_data.getString("data_introduzione"));
                        Log.i("DATA INTRO",dataIntroduzione.toString());

                        Piatto piatto= new Piatto(json_data.getString("nome"),
                                dataIntroduzione);
                        Log.i("PIATTO",piatto.getNome());
                        piatti.add(piatto);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    errorePiatti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(errorePiatti==true){
                return null;
            }
            return piatti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

    public boolean nuoviPiatti () {
        nuoviPiatti=false;

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/ultimaDataIntroduzione.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        SimpleDateFormat data= new SimpleDateFormat("yyyy-MM-dd");
                        Date dataIntroduzione=data.parse(json_data.getString("max_data"));
                        long oggi= Calendar.getInstance().getTimeInMillis();
                        if(oggi-dataIntroduzione.getTime()<(3*24*60*60*1000))
                            nuoviPiatti=true;

                        Log.i("DATA INTRO",nuoviPiatti+"");

                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreNuoviPiatti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreNuoviPiatti==true){
                return false;
            }
            return nuoviPiatti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return false;
    }

    public List<Progetto> leggiProgetti() {
        listaProgetti=new ArrayList<>();

        Thread t = new Thread(new Runnable() {
            public void run() {
                try {
                    URL url = new URL("http://soddb.altervista.org/leggiProgetti.php");
                    HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                    urlConnection.setReadTimeout(1000);
                    urlConnection.setConnectTimeout(1500);
                    urlConnection.setRequestMethod("POST");
                    urlConnection.setDoInput(true);
                    urlConnection.setDoOutput(true);

                    urlConnection.connect();
                    InputStream is = urlConnection.getInputStream();
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "iso-8859-1"), 8);
                    StringBuilder sb = new StringBuilder();
                    String line = null;
                    while ((line = reader.readLine()) != null) {
                        sb.append(line + "\n");
                    }
                    is.close();

                    String result = sb.toString();
                    Log.i("RESULT",result);
                    JSONArray jArray = new JSONArray(result);

                    for (int i = 0; i < jArray.length(); i++) {
                        JSONObject json_data = jArray.getJSONObject(i);

                        Progetto progetto = new Progetto(Html.fromHtml(json_data.getString("nome_progetto")),
                                Html.fromHtml(json_data.getString("descrizione_progetto")),
                                json_data.getString("img_progetto"));


                        // Log.i("DOMANDA", faq.getDomanda());
                        listaProgetti.add(progetto);
                    }

                } catch (Exception e) {
                    Log.e("Errore", "Errore: " + e.toString());
                    erroreProgetti=true;
                }

            }

        });
        t.start();
        try {
            //attende la terminazione del thread
            t.join();
            if(erroreProgetti==true){
                return null;
            }
            return listaProgetti;
        }catch(InterruptedException ie){
            Log.i("Errore", "Errore: "+ie.toString());
        }
        return null;
    }

}
