package it.pmsc.myapplication;

import android.app.PendingIntent;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.MenuItem;

import androidx.appcompat.app.ActionBarDrawerToggle;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.app.NotificationCompat;
import androidx.core.app.NotificationManagerCompat;
import androidx.core.view.GravityCompat;
import androidx.drawerlayout.widget.DrawerLayout;
import com.google.android.material.navigation.NavigationView;
import it.pmsc.myapplication.caseone.LoyaltyProgramOneActivity;
import it.pmsc.myapplication.casethree.LoyaltyProgramThreeActivity;
import it.pmsc.myapplication.casetwo.LoyaltyProgramTwoActivity;
import it.pmsc.myapplication.csr.AboutUsActivity;
import it.pmsc.myapplication.mappe.MapActivity;
import it.pmsc.myapplication.menu.MenuActivity;
import it.pmsc.myapplication.servizioclienti.FaqActivity;
import it.pmsc.myapplication.shop.ShopActivity;

import static it.pmsc.myapplication.Channel.CHANNEL_1_ID;

public class MainActivity extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    private int idNotifica;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        toolbar.setTitle("Home");

        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close);
        drawer.setDrawerListener(toggle);
        toggle.syncState();
        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);


    }
    @Override
    public void onBackPressed() {
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            moveTaskToBack(true);
        }
    }


    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        // Handle navigation view item clicks here.
        int id = item.getItemId();
        if (id == R.id.nav_maps) {
            Intent intent = new Intent (this, MapActivity.class);
            startActivity(intent);
        } else if (id == R.id.nav_pfone) {
            Intent intent = new Intent (this, LoyaltyProgramOneActivity.class);
            startActivity(intent);
        } else if (id == R.id.nav_pftwo) {
            Intent intent = new Intent (this, LoyaltyProgramTwoActivity.class);
            startActivity(intent);
        } else if (id == R.id.nav_pfthree) {
            Intent intent = new Intent (this, LoyaltyProgramThreeActivity.class);
            startActivity(intent);
        }else if (id == R.id.nav_chatbot) {
            Intent intent = new Intent (this, FaqActivity.class);
            startActivity(intent);
        }else if (id == R.id.nav_menu) {
            Intent intent = new Intent (this, MenuActivity.class);
            if(item.getActionView()!=null)
                item.setActionView(null);
            startActivity(intent);
        }else if (id == R.id.nav_shop) {
            Intent intent = new Intent (this, ShopActivity.class);
            if(item.getActionView()!=null){
                item.setActionView(null);
                intent.putExtra("notifica","mostraTuttiPiattiPronti");
            }
            startActivity(intent);
        }else if (id == R.id.nav_csr) {
            Intent intent = new Intent (this, AboutUsActivity.class);
            startActivity(intent);
        }else if (id == R.id.nav_notifica_inizio) {
            inviaNotificaInizio();
        }else if (id == R.id.nav_notifica_vinto) {
            inviaNotificaVinto();
        }else if (id == R.id.nav_notifica_perso) {
            inviaNotificaPerso();
        } else if (id == R.id.nav_notifica_prenotazione) {
            inviaNotificaPrenotazione();
        } else if (id == R.id.nav_notifica_nuovi_piatti) {
            inviaNotificaIntroduzioneNuoviPiatti();
            return true;
        }else if (id == R.id.nav_notifica_scadenza) {
            inviaNotificaProdottiScadenza();
        }else if (id == R.id.nav_notifica_piatti_pronti) {
            inviaNotificaPiattiPronti();
            return true;
        }
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawer.closeDrawer(GravityCompat.START);
        return true;
    }

    private void inviaNotificaInizio () {
        Intent intent = new Intent(this, LoyaltyProgramTwoActivity.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        intent.putExtra("Fragment", "WeekChallengeTwoFragment");
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_1_ID)
                .setSmallIcon(R.drawable.logo)
                .setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.inizio_sfida))
                .setColor(Color.BLUE)
                //.addAction(R.drawable.common_google_signin_btn_icon_light, "I Tuoi Premi", pendingIntent)
                //.addAction(R.drawable.common_google_signin_btn_icon_dark, "Ignora", null)
                .setContentTitle(Html.fromHtml("<b><font color='#999'>Nuova settimana... NUOVA SFIDA!</font></b>"))
                .setStyle(new NotificationCompat.BigTextStyle()
                        .bigText(Html.fromHtml("Vorresti sapere di cosa si tratta?")))
                .setContentIntent(pendingIntent)
                .setAutoCancel(true)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT);


        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        notificationManager.notify(idNotifica, builder.build());
        idNotifica++;
    }

    private void inviaNotificaVinto () {
        Intent intent = new Intent(this, LoyaltyProgramTwoActivity.class);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        intent.putExtra("Fragment", "PrizeTwoFragment");
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_1_ID)
                .setSmallIcon(R.drawable.logo)
                .setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.vinto_sfida))
                .setColor(Color.BLUE)
                .setContentTitle(Html.fromHtml("<b><font color='#999'>HAI VINTO!</font></b>"))
                .setStyle(new NotificationCompat.BigTextStyle()
                        .bigText(Html.fromHtml("Per saperne di più, visita la sezione <i>I Tuoi Premi</i>.")))
                .setContentIntent(pendingIntent)
                .setAutoCancel(true)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT);


        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        notificationManager.notify(idNotifica, builder.build());
        idNotifica++;
    }

    private void inviaNotificaPerso ()  {
        //ha perso, se clicca sulla notifica si apre l'applicazione nella schermata HOME (dell'app vera)
        Intent intent = new Intent(this, MainActivity.class);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_1_ID)
                .setSmallIcon(R.drawable.logo)
                .setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.perso_sfida))
                .setColor(Color.BLUE)
                .setContentTitle(Html.fromHtml("<b><font color='#999'>Che peccato!</font></b>"))
                .setStyle(new NotificationCompat.BigTextStyle()
                        .bigText(Html.fromHtml("Riprova la prossima settimana, andrà meglio!")))
                .setContentIntent(pendingIntent)
                .setAutoCancel(true)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT);


        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        notificationManager.notify(idNotifica, builder.build());
        idNotifica++;
    }

    private void inviaNotificaPrenotazione () {
        //ha prenotato un posto, se clicca sulla notifica si apre l'applicazione nel riepilogo della prenotazione (dell'app vera)
        Intent intent = new Intent(this, MainActivity.class);
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_1_ID)
                .setSmallIcon(R.drawable.logo)
                .setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.calendario))
                .setColor(Color.BLUE)
                .setContentTitle(Html.fromHtml("<b><font color='#999'>Promemoria prenotazione</font></b>"))
                .setStyle(new NotificationCompat.BigTextStyle()
                        .bigText(Html.fromHtml("Hai una prenotazione attiva tra 30 minuti!")))
                .setContentIntent(pendingIntent)
                .setAutoCancel(true)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT);


        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        notificationManager.notify(idNotifica, builder.build());
        idNotifica++;
    }

    private void inviaNotificaIntroduzioneNuoviPiatti (){
        DBAccess dbAccess= new DBAccess();
        boolean nuoviPiatti = dbAccess.nuoviPiatti();
        if(nuoviPiatti==true){
            NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
            navigationView.setNavigationItemSelectedListener(this);
            // showing dot next to notifications label
            navigationView.getMenu().getItem(5).setActionView(R.layout.menu_dot);
        }
    }

    private void inviaNotificaProdottiScadenza () {
        //nello shop ci sono dei prodotti in scadenza, l'intent manda direttamente allo shop
        Intent intent = new Intent(this, ShopActivity.class);
        intent.putExtra("notifica","mostraTuttiProdotti");
        PendingIntent pendingIntent = PendingIntent.getActivity(this, 4, intent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationCompat.Builder builder = new NotificationCompat.Builder(this, CHANNEL_1_ID)
                .setSmallIcon(R.drawable.logo)
                .setLargeIcon(BitmapFactory.decodeResource(getResources(), R.drawable.cestino))
                .setColor(Color.BLUE)
                .setContentTitle(Html.fromHtml("<b><font color='#999'>Hai dato un&#8242;occhiata allo shop?</font></b>"))
                .setStyle(new NotificationCompat.BigTextStyle()
                        .bigText(Html.fromHtml("Tutti i prodotti in scadenza hanno un cashback del 20% ... Affrettati!")))
                .setContentIntent(pendingIntent)
                .setAutoCancel(true)
                .setPriority(NotificationCompat.PRIORITY_DEFAULT);


        NotificationManagerCompat notificationManager = NotificationManagerCompat.from(this);
        notificationManager.notify(idNotifica, builder.build());
        idNotifica++;
    }

    private void inviaNotificaPiattiPronti (){
        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);
        // showing dot next to notifications label
        navigationView.getMenu().getItem(6).setActionView(R.layout.menu_dot);
    }
}