package it.pmsc.myapplication.caseone;

import android.graphics.Color;
import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;

import it.pmsc.myapplication.R;
/**
 * A simple {@link Fragment} subclass.
 */
public class LevelOneFragment extends Fragment {

    ProgressBar chiccoPb;
    ProgressBar spigaPb;
    ProgressBar farinaPb;
    ProgressBar pastaPb;
    TextView chiccoTv;
    TextView spigaTv;
    TextView farinaTv;
    TextView pastaTv;
    ImageView livelloImage;
    TextView puntiTv;

    int puntiAccumulati;
    int puntiMancanti;
    String livello;
    int puntiMin;
    int puntiMax;

    float progresso;

    public LevelOneFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {

        // Inflate the layout for this fragment
        View view= inflater.inflate(R.layout.fragment_level_one, container, false);

        chiccoPb=view.findViewById(R.id.chiccoPb);
        spigaPb=view.findViewById(R.id.spigaPb);
        farinaPb=view.findViewById(R.id.farinaPb);
        pastaPb=view.findViewById(R.id.pastaPb);


        chiccoPb.setScaleY(2f);
        chiccoPb.setMax(100);
        spigaPb.setScaleY(2f);
        spigaPb.setMax(100);
        farinaPb.setScaleY(2f);
        farinaPb.setMax(100);
        pastaPb.setScaleY(2f);
        pastaPb.setMax(100);
        livelloImage=view.findViewById(R.id.livello);
        puntiTv=view.findViewById(R.id.puntiTv);

        puntiAccumulati=600;
        puntiTv.setText(puntiAccumulati+" pt");
        livello=trovaLivello(puntiAccumulati);

        chiccoTv= view.findViewById(R.id.chiccoTv);
        spigaTv= view.findViewById(R.id.spigaTv);
        farinaTv=view.findViewById(R.id.farinaTv);
        pastaTv=view.findViewById(R.id.pastaTv);

        Log.i("Progresso",progresso+"");
        Log.i("Livello",livello);

        mostraProgresso(livello);

        return view;

    }


    private String trovaLivello(int punti){
        if(punti<500){
            livelloImage.setImageResource(R.drawable.chicco);
            return "C";
        }
        else if(punti>=500 && punti<1500){
            livelloImage.setImageResource(R.drawable.spiga);
            //livelloImage.getLayoutParams().height=250;
            //livelloImage.getLayoutParams().width=250;
            return "S";
        }
        else if(punti>=1500 && punti<3000){
            livelloImage.setImageResource(R.drawable.farina);
            return "F";
        }
        else{
            livelloImage.setImageResource(R.drawable.pasta);
            livelloImage.getLayoutParams().height=300;
            livelloImage.getLayoutParams().width=300;
            return "P";
        }
    }

    private int trovaMax(String livello){
        if(livello.compareTo("C")==0)
            return 500;
        else if(livello.compareTo("S")==0)
            return 1500;
        else if(livello.compareTo("F")==0)
            return 3000;
        else
            return 15000; //non c'è un massimo; all'ultimo livello la progressBar è completa
    }

    private int trovaMin(String livello){
        if(livello.compareTo("C")==0)
            return 0;
        else if(livello.compareTo("S")==0)
            return 500;
        else if(livello.compareTo("F")==0)
            return 1500;
        else
            return 3000;
    }

    private void mostraProgresso(String livello){
            puntiMin=trovaMin(livello);
            puntiMax=trovaMax(livello);
            puntiMancanti=puntiMax-puntiAccumulati;
            progresso = ((puntiAccumulati-puntiMin)*100)/(puntiMax-puntiMin);

            if(livello.compareTo("C")==0){
                String cString = "Livello "+"<b>" + "CHICCO" + "</b>"+" : "+puntiMancanti+" pt per il prossimo livello.";
                chiccoTv.setText(Html.fromHtml(cString));
                chiccoTv.setTextColor(Color.BLACK);
                chiccoPb.setProgress(Math.round(progresso));
            }else if(livello.compareTo("S")==0){
                String cString = "Livello "+"<b>" + "CHICCO" + "</b>"+" : completato!";
                chiccoTv.setText(Html.fromHtml(cString));
                chiccoTv.setTextColor(Color.BLACK);
                chiccoPb.setProgress(100);

                String sString = "Livello "+"<b>" + "SPIGA" + "</b>"+" : "+puntiMancanti+" pt per il prossimo livello.";
                spigaTv.setText(Html.fromHtml(sString));
                spigaTv.setTextColor(Color.BLACK);
                spigaPb.setProgress(Math.round(progresso));
            }else if(livello.compareTo("F")==0){
                String cString = "Livello "+"<b>" + "CHICCO" + "</b>"+" : completato!";
                chiccoTv.setText(Html.fromHtml(cString));
                chiccoTv.setTextColor(Color.BLACK);
                chiccoPb.setProgress(100);

                String sString = "Livello "+"<b>" + "SPIGA" + "</b>"+" : completato!";
                spigaTv.setText(Html.fromHtml(sString));
                spigaTv.setTextColor(Color.BLACK);
                spigaPb.setProgress(100);

                String fString = "Livello "+"<b>" + "FARINA" + "</b>"+" : "+puntiMancanti+" pt per il prossimo livello.";
                farinaTv.setText(Html.fromHtml(fString));
                farinaTv.setTextColor(Color.BLACK);
                farinaPb.setProgress(Math.round(progresso));

            }else if(livello.compareTo("P")==0){
                String cString = "Livello "+"<b>" + "CHICCO" + "</b>"+" : completato!";
                chiccoTv.setText(Html.fromHtml(cString));
                chiccoTv.setTextColor(Color.BLACK);
                chiccoPb.setProgress(100);

                String sString = "Livello "+"<b>" + "SPIGA" + "</b>"+" : completato!";
                spigaTv.setText(Html.fromHtml(sString));
                spigaTv.setTextColor(Color.BLACK);
                spigaPb.setProgress(100);

                String fString = "Livello "+"<b>" + "FARINA" + "</b>"+" : completato!";
                farinaTv.setText(Html.fromHtml(fString));
                farinaTv.setTextColor(Color.BLACK);
                farinaPb.setProgress(100);

                String pString = "Livello "+"<b>" + "PASTA" + "</b>"+" : raggiunto!";
                pastaTv.setText(Html.fromHtml(pString));
                pastaTv.setTextColor(Color.BLACK);
                pastaPb.setProgress(Math.round(progresso));
        }
    }
}
