package it.pmsc.myapplication.casethree;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import it.pmsc.myapplication.R;
import android.os.Bundle;
import android.text.Html;
import android.text.Spannable;
import android.text.SpannableStringBuilder;
import android.text.style.StyleSpan;

import java.util.ArrayList;
import java.util.List;

public class InfoThreeActivity extends AppCompatActivity {

    RecyclerView recyclerView;
    List<InfoItem> items;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_info_three);
        getSupportActionBar().setTitle("Programma Fedeltà");

        recyclerView = findViewById(R.id.recyclerView);

        String descrizioneWC = "<b>Come si partecipa?</b><br>" +
                " All&#8242;inizio della settimana riceverai una notifica che dà il via alla sfida: puoi consultare i dettagli nella sezione &#171;<i>Week Challenge</i>&#187;." +
                " Utilizza l&#8242;<b>applicazione</b> per compiere le azioni indicate nella descrizione della sfida.<br>" +
                " Alla fine della settimana riceverai una notifica con l&#8242;esito.<br><br>" +

                " <b>Come si vince?</b><br>" +
                " Immagina una ruota: più volte compi l&#8242;azione in descrizione più grande sarà la tua <b>porzione di ruota</b> e quindi maggiore sarà la tua probabilità di <b>vincere</b>!<br>" +
                " &Egrave; la ruota a decidere dove fermarsi... Ma puoi aiutarla a scegliere proprio <b>te</b>!<br><br>" +

                " <b>Cosa si vince?</b><br>" +
                " Fantastici premi o imperdibili vantaggi variabili ogni settimana!";

        String descrizioneAC = "<b>Come funziona?</b><br>" +
                " Ogni volta che fai un acquisto passa la Tua tessera per registrare la transazione. Nella sezione" +
                " <i>Annual Challenge</i> puoi controllare quanto hai speso. Raggiunti <b>20 euro</b> di spesa, riceverai un <b>premio sicuro</b>.<br><br>" +
                " <b>Qual è il premio?</b><br>" +
                " Un credito di <b>3 euro</b> da caricare direttamente nel borsellino elettronico dell'applicazione oppure un <b>premio personalizzato</b> creato su misura per te." +
                " Consulta la sezione <i>Annual Challenge</i> per visualizzare i premi accumulati e utilizzarli quando preferisci.<br><br>" +
                " <b>Cosa significa <i>personalizzazione dei premi</i>?</b><br>" +
                " Nella sezione <i>Annual Challenge</i>, spuntando la casella acconsenti al trattamento dei dati delle transazioni" +
                " per ricevere il <b>premio più adatto a te</b>. In qualunque momento potrai togliere la spunta e i dati saranno immediatamente eliminati.";

        items = new ArrayList<>();
        items.add(new InfoItem(R.drawable.gif_week_challenge, getString(R.string.week_challenge_title), descrizioneWC));
        items.add(new InfoItem(R.drawable.gif_annual_challenge, getString(R.string.annual_challenge_title), descrizioneAC));

        InfoAdapter adapter = new InfoAdapter(items);
        recyclerView.setAdapter(adapter);
        recyclerView.setHasFixedSize(true);
    }

}
