package it.pmsc.myapplication.casethree;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import it.pmsc.myapplication.R;

public class RowLayoutPrizesThreeAdapter  extends ArrayAdapter<String> {

    private final Activity context;
    private final String[] nome;
    private final String[] scadenza;
    private final Integer[] imgid;

    public RowLayoutPrizesThreeAdapter(Activity context, String[] nome, String[] scadenza, Integer[] imgid) {
        super(context, R.layout.row_layout_prizes_three, nome);

        this.context = context;
        this.nome = nome;
        this.scadenza = scadenza;
        this.imgid = imgid;

    }

    public View getView(int position, View view, ViewGroup parent) {
        LayoutInflater inflater = context.getLayoutInflater();
        View rowView = inflater.inflate(R.layout.row_layout_prizes_three, null, true);

        TextView nomeTv = (TextView) rowView.findViewById(R.id.prizeDesc);
        ImageView imageView = (ImageView) rowView.findViewById(R.id.prizeImage);
        TextView scadenzaTv = (TextView) rowView.findViewById(R.id.prizeExp);

        nomeTv.setText(nome[position]);
        imageView.setImageResource(imgid[position]);
        scadenzaTv.append(scadenza[position]);

        return rowView;

    }
}
