package it.pmsc.myapplication.casetwo;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;

import it.pmsc.myapplication.R;

public class RowAdapter extends ArrayAdapter<String> {

    private final Activity context;
    private final String[] nome;
    private final String[] emissione;
    private final String[] scadenza;
    private final Integer[] imgid;

    public RowAdapter(Activity context, String[] nome, String[] emissione, String[] scadenza, Integer[] imgid) {
        super(context, R.layout.row_layout, nome);
// TODO Auto-generated constructor stub

        this.context = context;
        this.nome = nome;
        this.emissione = emissione;
        this.scadenza = scadenza;
        this.imgid = imgid;

    }

    public View getView(int position, View view, ViewGroup parent) {
        LayoutInflater inflater = context.getLayoutInflater();
        View rowView = inflater.inflate(R.layout.row_layout, null, true);

        TextView nomeTv = (TextView) rowView.findViewById(R.id.nome);
        ImageView imageView = (ImageView) rowView.findViewById(R.id.icon);
        TextView emissioneTv = (TextView) rowView.findViewById(R.id.emissione);
        TextView scadenzaTv = (TextView) rowView.findViewById(R.id.scadenza);

        nomeTv.setText(nome[position]);
        imageView.setImageResource(imgid[position]);
        emissioneTv.append(emissione[position]);
        scadenzaTv.append(scadenza[position]);

        return rowView;

    }
}