package it.pmsc.myapplication.csr;

import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Adapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.SearchView;

import java.util.ArrayList;
import java.util.List;

import it.pmsc.myapplication.DBAccess;
import it.pmsc.myapplication.MainActivity;
import it.pmsc.myapplication.R;
import it.pmsc.myapplication.servizioclienti.FaqActivity;

public class AboutUsActivity extends AppCompatActivity {

    List<Progetto> progettiDB;
    List<Progetto> progettiResult;
    DBAccess dbAccess;
    Dialog dialog;
    ImageView close;
    ListView listView;
    ProgettoAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_about_us);
        getSupportActionBar().setTitle(R.string.menu_csr);
        dbAccess = new DBAccess();
        progettiDB = new ArrayList<>();
        progettiDB = dbAccess.leggiProgetti();

        progettiResult = new ArrayList<>();
        listView=findViewById(R.id.listview_progetti);

        adapter=new ProgettoAdapter(this,progettiResult);
        listView.setAdapter(adapter);
        initListData();
        filterData();
    }

    private void initListData() {
        if(progettiDB==null){
            dialog=new Dialog(this);
            dialog.setContentView(R.layout.dialog_errore);
            close=(ImageView) dialog.findViewById(R.id.close_popup);
            Button ok = dialog.findViewById(R.id.btn_accept);
            close.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    dialog.dismiss();
                }
            });
            ok.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent i= new Intent(AboutUsActivity.this, MainActivity.class);
                    startActivity(i);
                }
            });

            dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            dialog.show();

        }else {
            progettiResult.addAll(progettiDB);
            adapter.notifyDataSetChanged();
        }

    }


    public void filterData(){
        SearchView sv= findViewById(R.id.searchProgetti);
        sv.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String query) {
                InputMethodManager inputMethodManager = (InputMethodManager) getSystemService(Activity.INPUT_METHOD_SERVICE);
                inputMethodManager.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
                return true;
            }

            @Override
            public boolean onQueryTextChange(String query) {
                query= query.toLowerCase();
                progettiResult.clear();
                if(query.isEmpty()){
                    progettiResult.addAll(progettiDB);
                }else{
                    for(int i=0; i<progettiDB.size();i++ ){

                        if(progettiDB.get(i).getTitolo().toString().toLowerCase().contains(query) || progettiDB.get(i).getDescrizione().toString().toLowerCase().contains(query)){
                            progettiResult.add(progettiDB.get(i));
                            Log.i("TITOLO ",progettiDB.get(i).getTitolo().toString());
                            Log.i("DESCRIZIONR ",progettiDB.get(i).getDescrizione().toString());
                        }
                    }
                }
                adapter.notifyDataSetChanged();
                return true;
            }
        });

    }

}
