package it.pmsc.myapplication.csr;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.os.Build;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.RequiresApi;

import java.util.List;

import it.pmsc.myapplication.R;

public class ProgettoAdapter extends ArrayAdapter<Progetto> {

    private final Activity context;
    private final List<Progetto> progetti;

    public ProgettoAdapter(Activity context, List<Progetto> progetti) {
        super(context, R.layout.progetto_layout);
        this.context = context;
        this.progetti=progetti;
    }


    @RequiresApi(api = Build.VERSION_CODES.O)
    @SuppressLint("ResourceType")
    public View getView(final int position, View convertView, ViewGroup parent) {
        LayoutInflater inflater = context.getLayoutInflater();
        View view= convertView;
        final ProgettoAdapter.ProgettoVH holder;
        try{
            if(convertView==null){
                view=inflater.inflate(R.layout.progetto_layout,null);
                holder=new ProgettoAdapter.ProgettoVH();
                holder.nomeProgetto=view.findViewById(R.id.nome_progetto);
                holder.descrizioneProgetto=view.findViewById(R.id.descrizione_progetto);
                holder.imgProgetto=view.findViewById(R.id.img_progetto);

                view.setTag(holder);
            }else{
                holder= (ProgettoAdapter.ProgettoVH) view.getTag();
            }

            holder.nomeProgetto.setText(progetti.get(position).getTitolo());
            holder.descrizioneProgetto.setText(progetti.get(position).getDescrizione());
            holder.imgProgetto.setImageResource(context.getResources().getIdentifier("drawable/"+progetti.get(position).getImg(),
                    null,context.getPackageName()));


        } catch (Exception e) {
            e.printStackTrace();
        }

        return view;

    }

    public static class ProgettoVH {
        public TextView nomeProgetto;
        public TextView descrizioneProgetto;
        public ImageView imgProgetto;
    }

    public int getCount(){
        return progetti.size();
    }

    public Progetto getItem(Progetto position){
        return position;
    }

    public long getItemId(int position){
        return position;
    }



}