package it.pmsc.myapplication.menu;

import android.app.Activity;
import android.graphics.Color;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.firebase.database.ValueEventListener;

import java.util.Calendar;
import java.util.List;

import it.pmsc.myapplication.R;


public class PiattoAdapter extends ArrayAdapter<Piatto> {

    private final Activity context;
    private final List<Piatto> listaPiatti;
    long oggi= Calendar.getInstance().getTimeInMillis();


    public PiattoAdapter(Activity context, List<Piatto> listaPiatti) {
        super(context, R.layout.piatto_layout);
        this.context = context;
        this.listaPiatti=listaPiatti;
    }


    public View getView(final int position, View convertView, ViewGroup parent) {
        LayoutInflater inflater = context.getLayoutInflater();
        View view= convertView;
        final PiattoAdapter.PiattoVH holder;
        try{
            if(convertView==null){
                view=inflater.inflate(R.layout.piatto_layout,null);
                holder=new PiattoAdapter.PiattoVH();
                holder.nomePiattoTv=view.findViewById(R.id.nomePiattoTv);
                holder.expandable=view.findViewById(R.id.expandable);
                holder.dettagli=view.findViewById(R.id.infoPiatti);
                holder.piattoNew=view.findViewById(R.id.piattoNew);
                holder.cliccato=false;
                view.setTag(holder);
            }else{
                holder= (PiattoAdapter.PiattoVH) view.getTag();
            }

            holder.nomePiattoTv.setText(listaPiatti.get(position).getNome());

            holder.expandable.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                    if(holder.dettagli.getVisibility()==View.GONE) {
                        holder.dettagli.setVisibility(View.VISIBLE);
                        holder.expandable.setImageResource(R.drawable.ic_keyboard_arrow_up_black_24dp);
                        holder.cliccato=true;
                    }
                    else{
                        holder.dettagli.setVisibility(View.GONE);
                        holder.expandable.setImageResource(R.drawable.ic_expand_more_black_24dp);
                    }

                    notifyDataSetChanged();

                }
            });


            //mostriamo la scritta new se il piatto è stato introdotto negli ultimi 3 giorni
            long dataI=(listaPiatti.get(position).getDataIntroduzione()).getTime();
            long differenza=(oggi-dataI)/(1000*60*60*24);

            //Log.i("differenza",listaProdotti.get(position).getNome()+" "+differenza+"");
            if(differenza<3 && holder.cliccato==false){
                holder.piattoNew.setVisibility(View.VISIBLE);
            }else{
                holder.piattoNew.setVisibility(View.GONE);
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

        return view;

    }

    public static class PiattoVH {
        public TextView nomePiattoTv;
        public ImageView expandable;
        public LinearLayout dettagli;
        public TextView piattoNew;
        public boolean cliccato;
    }

    public int getCount(){
        return listaPiatti.size();
    }

    public Piatto getItem(Piatto position){
        return position;
    }

    public long getItemId(int position){
        return position;
    }

}