package it.pmsc.myapplication.servizioclienti;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.text.Html;
import android.text.Spanned;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;

import java.util.ArrayList;

import it.pmsc.myapplication.R;


public class ChatActivity<FloatingActionButton> extends AppCompatActivity {


    private ListView mListView;
    private Button mButtonSend;
    private EditText mEditTextMessage;
    private ChatMessageAdapter mAdapter;
    private String type;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chat);
        getSupportActionBar().setTitle(R.string.menu_chatbot);
        getWindow().setBackgroundDrawableResource(R.drawable.sfondo_chat);

        mListView = (ListView) findViewById(R.id.listView);
        mButtonSend = findViewById(R.id.btn_send);
        mEditTextMessage = (EditText) findViewById(R.id.et_message);
        mAdapter = new ChatMessageAdapter(this, new ArrayList<ChatMessage>());
        mListView.setAdapter(mAdapter);
        type="N";

        mimicOtherMessage("Ciao sono <b>Tell<i>My</i></b>!<br>Scrivi &quot;<i>assistenza</i>&quot; " +
                        "se hai bisogno di aiuto o &quot;<i>suggerimenti</i>&quot; " +
                        "se vuoi aiutarci a migliorare.");

        //code for sending the message
        mButtonSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String message = mEditTextMessage.getText().toString();
                sendMessage(message);
                mEditTextMessage.setText("");
                mListView.setSelection(mAdapter.getCount() - 1);
            }
        });
    }

    private void sendMessage(String message) {

        ChatMessage chatMessage = new ChatMessage(message, true);
        mAdapter.add(chatMessage);

        //il flag type può assumere 3 valori: A=l'utente ha scritto assistenza
        //S=l'utente ha scritto suggerimenti
        //N=l'utente non ha scritto nessuno parola valida
        if(message.toLowerCase().trim().compareTo("assistenza")==0){
            mimicOtherMessage("Sono qui per ascoltarti. Cosa è andato storto?");
            type="A";
        }
        else if (message.toLowerCase().trim().compareTo("suggerimenti")==0){
            mimicOtherMessage("Inserisci qui le tue proposte... Sono lieto di ascoltarti!");
            type="S";
        }
        else if(type.equals("N"))
            mimicOtherMessage("Scrivi &quot;<i>assistenza</i>&quot; se hai bisogno di aiuto o &quot;<i>suggerimenti</i>&quot; se vuoi aiutarci a migliorare.");
            //se prima mi avevi chiesto o assistenza o suggerimenti e il secondo messaggio
            // è diverso da assistenza o suggerimenti lo memorizzo
        else if(type.equals("A")){
            mimicOtherMessage("Le tue richieste verranno prese in carico al più presto.");
            //memorizzare la richiesta in un DB
            type="N";
        }
        else if(type.equals("S")){
            mimicOtherMessage("Grazie per il tuo aiuto. I Vostri suggerimenti sono molto preziosi!");
            //memorizzare i suggerimenti in un DB
            type="N";
        }
    }

    private void mimicOtherMessage(String message) {
        ChatMessage chatMessage = new ChatMessage(message, false);
        mAdapter.add(chatMessage);
    }


}