package it.pmsc.myapplication.servizioclienti;

import android.content.Context;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import java.util.List;

import it.pmsc.myapplication.R;


public class ChatMessageAdapter extends ArrayAdapter<ChatMessage> {
    private static final int MY_MESSAGE = 0, OTHER_MESSAGE = 1;

    public ChatMessageAdapter(Context context, List<ChatMessage> data) {
        super(context, R.layout.item_mine_message, data);
    }
    @Override
    public int getViewTypeCount() {
        return 4;
    }
    @Override
    public int getItemViewType(int position) {
        ChatMessage item = getItem(position);
        if (item.isMine()) return MY_MESSAGE;
        else return OTHER_MESSAGE;

    }
    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        int viewType = getItemViewType(position);
        if (viewType == MY_MESSAGE) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.item_mine_message, parent, false);
            final TextView textView = (TextView) convertView.findViewById(R.id.text);
            textView.setText(getItem(position).getContent());
/*
            convertView.findViewById(R.id.chatMessageView).setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //eventualmente aggiungere un menu per copiare il testo del messaggio inviato in chat
                    //per poterlo poi incollare nella tastiera (funzione che c'è già)
                }
            });

 */
        } else if (viewType == OTHER_MESSAGE) {
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.item_other_message, parent, false);
            TextView textView = (TextView) convertView.findViewById(R.id.text);
            textView.setText(Html.fromHtml(getItem(position).getContent()));
        }

        return convertView;
    }
}
