package it.pmsc.myapplication.servizioclienti;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.SearchView;

import com.google.android.material.floatingactionbutton.FloatingActionButton;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import it.pmsc.myapplication.DBAccess;
import it.pmsc.myapplication.MainActivity;
import it.pmsc.myapplication.R;
import it.pmsc.myapplication.mappe.MapActivity;

public class FaqActivity extends AppCompatActivity {

    private DBAccess dbAccess;
    private List<Faq> faqs;

    ExpandableListView expandableListView;
    List<String> listGroup;
    List<String> listItem;
    FaqAdapter adapter;
    Dialog dialog;
    ImageView close;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_faq);
        getSupportActionBar().setTitle(R.string.menu_chatbot);

        dbAccess= new DBAccess();
        faqs= new ArrayList<>();
        faqs=dbAccess.leggiFAQ();

        expandableListView=findViewById(R.id.expandable_listview);

        listGroup=new ArrayList<>();
        listItem= new ArrayList<>();

        adapter=new FaqAdapter(this,listGroup,listItem);
        expandableListView.setAdapter(adapter);
        initListData();
        filterData();

        FloatingActionButton fab = findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent i = new Intent(FaqActivity.this, ChatActivity.class);
                startActivity(i);
            }
        });

    }

    private void initListData() {
        if(faqs==null){
            dialog=new Dialog(this);
            dialog.setContentView(R.layout.dialog_errore);
            close=(ImageView) dialog.findViewById(R.id.close_popup);
            Button ok = dialog.findViewById(R.id.btn_accept);
            close.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    dialog.dismiss();
                }
            });
            ok.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent i= new Intent(FaqActivity.this, MainActivity.class);
                    startActivity(i);
                }
            });

            dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            dialog.show();

        }else {
            for (int i = 0; i < faqs.size(); i++) {
                listGroup.add(faqs.get(i).getDomanda().toString());
                listItem.add(faqs.get(i).getRisposta().toString());
            }
            adapter.notifyDataSetChanged();
        }

    }


    public void filterData(){
        SearchView sv= findViewById(R.id.searchFaq);
        sv.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String query) {
                for(int i=0; i<listGroup.size();i++)
                    expandableListView.expandGroup(i);
                adapter.notifyDataSetChanged();

                InputMethodManager inputMethodManager = (InputMethodManager) getSystemService(Activity.INPUT_METHOD_SERVICE);
                inputMethodManager.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
                return true;
            }

            @Override
            public boolean onQueryTextChange(String query) {
                for(int i=0; i<listGroup.size();i++)
                    expandableListView.collapseGroup(i);
                query= query.toLowerCase();
                listGroup.clear();
                listItem.clear();
                if(query.isEmpty()){
                    for (int i = 0; i < faqs.size(); i++){
                        listGroup.add(faqs.get(i).getDomanda().toString());
                        listItem.add(faqs.get(i).getRisposta().toString());
                    }
                }else{
                    for(int i=0; i<faqs.size();i++ ){
                        if(faqs.get(i).getDomanda().toString().contains(query) || faqs.get(i).getRisposta().toString().contains(query)){
                            listGroup.add(faqs.get(i).getDomanda().toString());
                            listItem.add(faqs.get(i).getRisposta().toString());
                        }
                    }
                }
                adapter.notifyDataSetChanged();
                return true;
            }
        });

    }

}
