package it.pmsc.myapplication.shop;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Build;
import android.os.PowerManager;
import android.text.Html;
import android.util.Log;
import android.widget.Toast;

import androidx.core.app.NotificationCompat;
import androidx.core.app.NotificationManagerCompat;

import it.pmsc.myapplication.R;

import static it.pmsc.myapplication.Channel.CHANNEL_1_ID;


public class Alarm extends BroadcastReceiver {
    public static final String ACTION_ALARM= "it.pmsc.myapplication.waste.ACTION_ALARM";
    int idNotifica = 0;
    Context context;

    @Override
    public void onReceive(Context context, Intent intent) {
        this.context=context;
        SharedPreferences prefs = context.getSharedPreferences("Allarme", Context.MODE_PRIVATE);
        Log.i("Preferenze ALLARME" ,prefs.toString());

//verificare l'intent che arriva
        if(ACTION_ALARM.equals(intent.getAction())) {

//crea notifica
            Log.i("Preferenze ALLARME" ,"MANDO NOTIFICA");
            sendNotification();

        }else if (intent.getAction().equals("android.intent.action.BOOT_COMPLETED")){
//Log.i("Alarm","dispositivo riavviato");
            Log.i("Preferenze ALLARME" ,"BOOT COMPLETATO MYMENSA");
            Toast.makeText(context, "BOOT MYSENSA", Toast.LENGTH_LONG).show();

//si imposta nuovamente l'allarme prendendo il valore di millis dalle preferenze
            long data = Long.parseLong(prefs.getString("Allarme",""));
            //long data = prefs.getLong("alarm",0);
            setAlarm(data);
        }
    }

    private void sendNotification(){
//per forzare l'accensione dello schermo
        PowerManager pm = (PowerManager) context.getSystemService(Context.POWER_SERVICE);
        boolean isScreenOn = Build.VERSION.SDK_INT >= 20 ? pm.isInteractive() : pm.isScreenOn(); // check if screen is on
        if (!isScreenOn) {
            PowerManager.WakeLock wl = pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK | PowerManager.ACQUIRE_CAUSES_WAKEUP, "myApp:notificationLock");
            wl.acquire(3000);
        }

        //clicca sul bottone "continua"
        Intent yesIntent = new Intent(context, ShoppingCartActivity.class);
        yesIntent.putExtra("notifica","continua");
        yesIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        PendingIntent yesPendingIntent = PendingIntent.getActivity(context,1, yesIntent, PendingIntent.FLAG_UPDATE_CURRENT);

        //clicca sul bottone "svuota carrello"
        Intent noIntent = new Intent(context, ShoppingCartActivity.class);
        noIntent.putExtra("notifica","svuotaCarrello");
        noIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        PendingIntent noPendingIntent = PendingIntent.getActivity(context, 2, noIntent, PendingIntent.FLAG_UPDATE_CURRENT);


        NotificationCompat.Builder builder = new NotificationCompat.Builder(context, CHANNEL_1_ID)
                    .setSmallIcon(R.drawable.logo)
                    .setLargeIcon(BitmapFactory.decodeResource(context.getResources(), R.drawable.carrello))
                    .setColor(Color.BLUE)
                    .setContentTitle(Html.fromHtml("<b><font color='#999'>&Egrave; rimasto qualcosa nel tuo carrello!</font></b>"))
                    .setStyle(new NotificationCompat.BigTextStyle()
                            .bigText(Html.fromHtml("Hai ancora 30 minuti per completare l&#8242;ordine.")))
                    .addAction(0, Html.fromHtml("<b><font color='#999'>CONTINUA</font></b>"), yesPendingIntent)
                    .addAction(0, Html.fromHtml("<b><font color='#999'>SVUOTA IL CARRELLO</font></b>"), noPendingIntent)
                    .setAutoCancel(true)
                    .setPriority(NotificationCompat.PRIORITY_HIGH);

            NotificationManagerCompat notificationManager = NotificationManagerCompat.from(context);
            notificationManager.notify(idNotifica, builder.build());
            idNotifica++;

    }

    private void setAlarm(Long data){
        Log.i("Preferenze ALLARME" ,"SETTO ALLARME DI NUOVO");
        Intent intentToFire= new Intent (context, Alarm.class);
        intentToFire.setAction(Alarm.ACTION_ALARM);
        PendingIntent alarmIntent = PendingIntent.getBroadcast(context,0, intentToFire,0);
        AlarmManager alarmManager= (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
        alarmManager.set(AlarmManager.RTC_WAKEUP, data, alarmIntent);
    }


}
